VERSION 5.00
Begin VB.Form frmDisplay 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Display APIz"
   ClientHeight    =   4980
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6060
   Icon            =   "IO Display.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4980
   ScaleWidth      =   6060
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picBanner 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   615
      Left            =   0
      MouseIcon       =   "IO Display.frx":0452
      MousePointer    =   99  'Custom
      Picture         =   "IO Display.frx":0894
      ScaleHeight     =   615
      ScaleWidth      =   6060
      TabIndex        =   3
      Top             =   0
      Width           =   6060
   End
   Begin VB.ListBox lstDispRes 
      Height          =   4155
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   3375
   End
   Begin VB.CommandButton cmdChangeRes 
      Caption         =   "Change Resultion"
      Height          =   375
      Left            =   3720
      TabIndex        =   1
      Top             =   720
      Width           =   2175
   End
   Begin VB.CommandButton cmdSettings 
      Caption         =   "Settings..."
      Height          =   375
      Left            =   3720
      TabIndex        =   0
      Top             =   1200
      Width           =   2175
   End
   Begin VB.Image imgDisplay 
      Height          =   480
      Left            =   5280
      Picture         =   "IO Display.frx":18BD
      Stretch         =   -1  'True
      Top             =   4200
      Width           =   585
   End
End
Attribute VB_Name = "frmDisplay"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'==================================================================
'
' Display Demo Window
'
' 29 September 2001
' 05 March 2002 - Added display frequency
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


Private WithEvents Display As DisplayIO
Attribute Display.VB_VarHelpID = -1


'------------------------------------------------------------------
' Storage for display resolutions

Private Type Resolution
  Width As Long
  Height As Long
  ColorDepth As Long
  Frequency As Long
End Type

Private Resolutions() As Resolution
Private NumItems As Long


'------------------------------------------------------------------
' Enum the resulations

Private Sub Form_Initialize()
  Dim I As Integer
  
  Set Display = New DisplayIO
  Display.EnumResultions
End Sub


'------------------------------------------------------------------
' Buttons

Private Sub cmdChangeRes_Click()
  Dim DispInfo As Resolution
  Dim Result As DispChangeResResult
  
  If lstDispRes.ListIndex = -1 Then
    MsgBox "You didn't select a resultion!", vbExclamation, "Change Resultion"
  Else
    DispInfo = Resolutions(lstDispRes.ListIndex)
    On Error Resume Next
      ' Error when result < 0
      Result = Display.ChangeSettings(DispInfo.Width, DispInfo.Height, DispInfo.ColorDepth, DispInfo.Frequency, CDS_FORCE)
    On Error GoTo 0
    
    Select Case Result
      Case DISP_CHANGE_SUCCESSFUL
        MsgBox "The display resultion has changed.", vbInformation, "Change Resultion"
      Case DISP_CHANGE_RESTART
        MsgBox "You need to restart your computer now!", vbInformation, "Change Resultion"
      Case DISP_CHANGE_NOTUPDATED
        MsgBox "The display resultion has been updated.", vbInformation, "Change Resultion"
      Case DISP_CHANGE_FAILED
        MsgBox "Windows failed to change display resultion!", vbExclamation, "Change Resultion"
      Case Else ' Result="ErrorCode"
        MsgBox "This program appears to have a bug!", vbCritical, "Change Resultion"
    End Select
  End If
End Sub

Private Sub cmdSettings_Click()
  Call Display.ShowSettings
End Sub


'------------------------------------------------------------------
' Resolution Found, add to list

Private Sub Display_GotResolution(Width As Long, Height As Long, ColorDepth As Long, ColorName As String, Colors As Currency, Frequency As Long, ContinueEnum As Boolean)
  Dim Text As String
       
       
  Text = Text & Width & "x" & Height
  Text = Text & " (" & ColorName & "), "
  If Frequency = 1 Then
    Text = Text & "Default Refresh"
  Else
    Text = Text & Frequency & " Hertz"
  End If
  
  Call lstDispRes.AddItem(Text)
  lstDispRes.ItemData(lstDispRes.NewIndex) = NumItems
  
  ' Save settings for later use
  If NumItems = 0 Then
    ReDim Resolutions(0 To NumItems) As Resolution
    NumItems = 1
  Else
    ReDim Preserve Resolutions(0 To NumItems) As Resolution
    NumItems = NumItems + 1
  End If
  
  With Resolutions(UBound(Resolutions))
    .Height = Height
    .Width = Width
    .ColorDepth = ColorDepth
    .Frequency = Frequency
  End With
  
  ContinueEnum = True
End Sub



'------------------------------------------------------------------
' Banner

Private Sub picBanner_Click()
  MsgBox "Copyright  2001 - Diederik van der Boor" & vbCrLf _
       & vbCrLf _
       & "Anyone is allowed to use this software freely, as long as" & vbCrLf _
       & "the the copright information in the source code remains intact." & vbCrLf _
       & vbCrLf _
       & "http://www.codingdomain.com"
End Sub


